package com.ruoyi.info.order.enums;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.annotation.EnumValue;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;
import com.ruoyi.common.enums.IIntegerEnum;

import java.util.Objects;

public enum CancellationMethod implements IIntegerEnum<Integer> {

    user_canceled(10, "用户取消"),
    platform_canceled(20, "平台取消"),
    teacher_canceled(40, "管理老师取消"),
    auto_canceled(30, "未支付自动取消"),
    ;

    CancellationMethod(Integer code, String msg) {
        this.code = code;
        this.msg = msg;
    }

    @EnumValue
    @JsonValue
    private Integer code;

    private String msg;

    @Override
    public Integer getCode() {
        return code;
    }

    public void setCode(Integer code) {
        this.code = code;
    }

    @Override
    public String getMsg() {
        return msg;
    }

    public void setMsg(String msg) {
        this.msg = msg;
    }

    @JsonCreator
    public static CancellationMethod getByCode(Integer code) {
        for (CancellationMethod value : CancellationMethod.values()) {
            if (Objects.equals(code, value.getCode())) {
                return value;
            }
        }
        return null;
    }

    //转成jsonarray
    public static JSONArray toJsonArray() {
        JSONArray jsonArray = new JSONArray();
        for (CancellationMethod value : CancellationMethod.values()) {
            JSONObject jsonObject = new JSONObject();
            jsonObject.put("code", value.getCode());
            jsonObject.put("value", value.getMsg());
            jsonArray.add(jsonObject);
        }
        return jsonArray;
    }

}
